﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.IO;
using CompanyBussiness;

namespace Website.customer.Control
{
    public partial class News : System.Web.UI.UserControl
    {
        HtmlMeta metaTag;
        NewsManagement newsMana = new NewsManagement();
        LanguagesManagement languageMana = new LanguagesManagement();
        CompanyBussiness.New news = new New();
        CompanyBussiness.Language language;
        Metadata meta;
        int newsIDs;
        string modulCode;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                if (Request[CONST.QUERYSTRING_NEWS] == null)
                {
                    //quay ve trang home
                    Response.Redirect("~/Hem.html");
                }
                else
                {
                    LoadContent();
                }
            }
        }

        protected void LoadContent()
        {
            try
            {
                newsIDs = int.Parse(Request[CONST.QUERYSTRING_NEWS].ToString());
                news = newsMana.GetNewsByID(newsIDs);

                lbSubject.Text = news.NewsSubject;
                if (news.NewsImage != string.Empty)
                {
                    imgNews.ImageUrl = news.NewsImage.Replace("img_", "larger_");
                    imgNews.ToolTip = news.NewsSubject;
                }
                else
                {
                    imgNews.Visible = false;
                    imgNews.Style.Add("display","none");
                }

                litIntro.Text = news.NewsIntro;
                lbContent.InnerHtml = news.NewsContent;
                lbDate.Text = news.NewsDateCreate.ToString();
                if (news.FileAttach != null)
                {
                    lnkFile.Text = Path.GetFileName(news.FileAttach);
                    lnkFile.NavigateUrl = Server.MapPath(news.FileAttach).Replace("\\", "/");
                }

                meta = newsMana.GetMetadataByNewsID(newsIDs);
                if (meta != null)
                {
                    //Page.Header.Controls.Clear();
                   

                    //ghi metadata
                    metaTag = new HtmlMeta();
                    metaTag.Name = "keywords";
                    metaTag.Content = meta.MetaKeyword;
                    Page.Header.Controls.Add(metaTag);

                    metaTag = new HtmlMeta();
                    metaTag.Name = "description";
                    metaTag.Content = meta.MetaDesciption;
                    Page.Header.Controls.Add(metaTag);

                    Page.Header.Title = meta.Title;
                }
            }
            catch (Exception)
            {

            }
        }
    }
}